<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" >

  <xsl:variable name="Single">
    <xsl:text/>Single<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Multi">
    <xsl:text/>Multi<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Integer">
    <xsl:text/>Integer<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Float">
    <xsl:text/>Float<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Character">
    <xsl:text/>Char<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Date">
    <xsl:text/>Date<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Time">
    <xsl:text/>Time<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Verbatim">
    <xsl:text/>Verbatim<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Filter_Not">
    <xsl:text/>Not&#160;<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Hold">
    <xsl:text/>Hold<xsl:text/>
  </xsl:variable>


  <xsl:attribute-set name="FontInfo">
    <xsl:attribute name="size">2</xsl:attribute>
    <xsl:attribute name="color">#556B2F</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontHighlight">
    <xsl:attribute name="size">2</xsl:attribute>
    <xsl:attribute name="color">#DC143C</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontGlobalDetails">
    <xsl:attribute name="size">2</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontEntryName">
    <xsl:attribute name="size">3</xsl:attribute>
    <xsl:attribute name="color">#000080</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontEntryText">
    <xsl:attribute name="size">3</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontInstructions">
    <xsl:attribute name="size">2</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontResponseText">
    <xsl:attribute name="size">2</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontResponseNumber">
    <xsl:attribute name="size">2</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontResponseKey">
    <xsl:attribute name="size">2</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontResponseCode">
    <xsl:attribute name="size">2</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontSyntax">
    <xsl:attribute name="size">2</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontAnswerType">
    <xsl:attribute name="size">2</xsl:attribute>
    <xsl:attribute name="color">#556B2F</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontEntryInfo">
    <xsl:attribute name="size">2</xsl:attribute>
    <xsl:attribute name="color">#556B2F</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontFilterListPos">
    <xsl:attribute name="size">1</xsl:attribute>
    <xsl:attribute name="color">#006400</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontFilterListNeg">
    <xsl:attribute name="size">1</xsl:attribute>
    <xsl:attribute name="color">#8B0000</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontFilterTextPos">
    <xsl:attribute name="size">2</xsl:attribute>
    <xsl:attribute name="color">#006400</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontFilterTextNeg">
    <xsl:attribute name="size">2</xsl:attribute>
    <xsl:attribute name="color">#8B0000</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontDataLocations">
    <xsl:attribute name="size">2</xsl:attribute>
    <xsl:attribute name="color">#800000</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontProgramEntry">
    <xsl:attribute name="size">1</xsl:attribute>
    <xsl:attribute name="color">#008080</xsl:attribute>
  </xsl:attribute-set>

  <xsl:template match="ProjectDetails">
    <HTML>
      <BASEFONT face="Arial"/>
      <FONT face="Arial">
        <BODY>
          <xsl:apply-templates select="Entries"/>
        </BODY>
      </FONT>
    </HTML>
  </xsl:template>

  <xsl:template match="Entry[@EType='Question']">
    <TABLE cellspacing="1" cellpadding="1" width="100%" border="1" frame="above" rules="cols">
      <TR>
        <TD width="20%" valign="top">
          <FONT xsl:use-attribute-sets="FontEntryName">
            <xsl:value-of select="@EName"/>
          </FONT>
        </TD>
        <TD width="70%" valign="top">
          <FONT xsl:use-attribute-sets="FontEntryText">
            <xsl:value-of select="Text"/>
          </FONT>
        </TD>
        <TD width="10%" valign="top">
          <xsl:apply-templates select="@AType"/>
        </TD>
      </TR>
    </TABLE>
  </xsl:template>

  <xsl:template match="@AType">
    <xsl:if test="not(.='None')">
      <FONT xsl:use-attribute-sets="FontAnswerType">
        <I>
          <xsl:if test=".='Single'">
            <xsl:value-of select="$Single"/>
          </xsl:if>
          <xsl:if test=".='Multi'">
            <xsl:value-of select="$Multi"/>
          </xsl:if>
          <xsl:if test=".='Integer'">
            <xsl:value-of select="$Integer"/>
          </xsl:if>
          <xsl:if test=".='Float'">
            <xsl:value-of select="$Float"/>
          </xsl:if>
          <xsl:if test=".='Character'">
            <xsl:value-of select="$Character"/>
          </xsl:if>
          <xsl:if test=".='Date'">
            <xsl:value-of select="$Date"/>
          </xsl:if>
          <xsl:if test=".='Time'">
            <xsl:value-of select="$Time"/>
          </xsl:if>
          <xsl:if test=".='Verbatim'">
            <xsl:value-of select="$Verbatim"/>
          </xsl:if>
        </I>
      </FONT>
    </xsl:if>
  </xsl:template>
  
  <xsl:template match="Entry[@EType='Filter']">
  </xsl:template>

  <xsl:template match="Entry[@EType='Variable']">
  </xsl:template>

  <xsl:template match="Entry[@EType='Program']">
  </xsl:template>

</xsl:stylesheet>
