<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" >

  <xsl:variable name="Single">
    <xsl:text/>Single<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Multi">
    <xsl:text/>Multi<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Integer">
    <xsl:text/>Integer<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Float">
    <xsl:text/>Float<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Character">
    <xsl:text/>Char<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Date">
    <xsl:text/>Date<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Time">
    <xsl:text/>Time<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Verbatim">
    <xsl:text/>Verbatim<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Filter_Not">
    <xsl:text/>Not&#160;<xsl:text/>
  </xsl:variable>

  <xsl:attribute-set name="FontEntryName">
    <xsl:attribute name="size">1</xsl:attribute>
    <xsl:attribute name="color">#556B2F</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontAnswerType">
    <xsl:attribute name="size">1</xsl:attribute>
    <xsl:attribute name="color">#556B2F</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontInstructions">
    <xsl:attribute name="size">2</xsl:attribute>
  </xsl:attribute-set>

  <xsl:template match="ProjectDetails">
    <HTML>
      <BASEFONT face="Arial"/>
      <FONT face="Arial">
        <HEAD>
          <B>
            <xsl:value-of select="ProjectTitle"/>
          </B>
        </HEAD>
        <BODY>
          <xsl:apply-templates select="Entries"/>
        </BODY>
      </FONT>
    </HTML>
  </xsl:template>

  <xsl:template match="Entry[@EType='Question']">
    <xsl:if test="not(starts-with(@EName, 'ZZZ'))">
      <xsl:if test="Instruct">
        <TABLE cellspacing="1" cellpadding="0" width="100%" border="1" frame="above" rules="cols">
          <TR>
            <TD width="10%" valign="top">
              <FONT xsl:use-attribute-sets="FontEntryName">
                <xsl:value-of select="@EName"/>
              </FONT>
            </TD>
            <xsl:if test="Instruct/@TColour">
              <TD width="80%" valign="top">
                <xsl:attribute name="bgcolor">
                  <xsl:value-of select="substring(Instruct/@TColour, 3)"/>
                </xsl:attribute>
                <FONT xsl:use-attribute-sets="FontInstructions">
                  <xsl:if test="not(Instruct/Text='')">
                    <xsl:value-of select="Instruct/Text"/>
                  </xsl:if>
                  <xsl:if test="Instruct/Text=''">
                    <xsl:text/>&#160;<xsl:text/>
                  </xsl:if>
                </FONT>
              </TD>
            </xsl:if>
            <xsl:if test="not(Instruct/@TColour)">
              <TD width="80%" valign="top">
                <FONT xsl:use-attribute-sets="FontInstructions">
                  <xsl:value-of select="Instruct/Text"/>
                </FONT>
              </TD>
            </xsl:if>
            <TD width="10%" valign="top" align="center">
              <xsl:apply-templates select="@AType"/>
            </TD>
          </TR>
        </TABLE>
      </xsl:if>
    </xsl:if>
  </xsl:template>

  <xsl:template match="Entry[@EType='Filter']">
  </xsl:template>

  <xsl:template match="Entry[@EType='Variable']">
  </xsl:template>

  <xsl:template match="Entry[@EType='Program']">
  </xsl:template>

  <xsl:template match="@AType">
    <xsl:if test="not(.='None')">
      <FONT xsl:use-attribute-sets="FontAnswerType">
        <I>
          <xsl:if test=".='Single'">
            <xsl:value-of select="$Single"/>
          </xsl:if>
          <xsl:if test=".='Multi'">
            <xsl:value-of select="$Multi"/>
          </xsl:if>
          <xsl:if test=".='Integer'">
            <xsl:value-of select="$Integer"/>
          </xsl:if>
          <xsl:if test=".='Float'">
            <xsl:value-of select="$Float"/>
          </xsl:if>
          <xsl:if test=".='Character'">
            <xsl:value-of select="$Character"/>
          </xsl:if>
          <xsl:if test=".='Date'">
            <xsl:value-of select="$Date"/>
          </xsl:if>
          <xsl:if test=".='Time'">
            <xsl:value-of select="$Time"/>
          </xsl:if>
          <xsl:if test=".='Verbatim'">
            <xsl:value-of select="$Verbatim"/>
          </xsl:if>
        </I>
      </FONT>
    </xsl:if>
  </xsl:template>

</xsl:stylesheet>
