<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" >

  <xsl:variable name="Single">
    <xsl:text/>Single<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Multi">
    <xsl:text/>Multi<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Integer">
    <xsl:text/>Integer<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Float">
    <xsl:text/>Float<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Character">
    <xsl:text/>Char<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Date">
    <xsl:text/>Date<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Time">
    <xsl:text/>Time<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Verbatim">
    <xsl:text/>Verbatim<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Filter_Not">
    <xsl:text/>Not&#160;<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Routing_Close">
    <xsl:text/>Close<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Routing_Ineligible">
    <xsl:text/>Ineligible<xsl:text/>
  </xsl:variable>

  <xsl:variable name="Data_storage_file_type">
    <xsl:text/>Data storage file type&#160;<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Binary">
    <xsl:text/>Binary<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Code_order">
    <xsl:text/>Code order<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Data_record_layout">
    <xsl:text/>Data record layout&#160;<xsl:text/>
  </xsl:variable>
  <xsl:variable name="As_cards">
    <xsl:text/>As cards of&#160;<xsl:text/>
  </xsl:variable>
  <xsl:variable name="As_one_line">
    <xsl:text/>As one line of&#160;<xsl:text/>
  </xsl:variable>
  <xsl:variable name="columns">
    <xsl:text/>&#160;columns<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Serial_number_width">
    <xsl:text/>Serial number width&#160;<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Serial_number_locations">
    <xsl:text/>Serial number locations&#160;<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Card_number_width">
    <xsl:text/>Card number width&#160;<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Card_number_locations">
    <xsl:text/>Card number locations&#160;<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Card_number_location">
    <xsl:text/>Card number location&#160;<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Digits_card_numbers">
    <xsl:text/>Last digits used for card numbers&#160;<xsl:text/>
  </xsl:variable>
  <xsl:variable name="Card_numbers">
    <xsl:text/>Card numbers&#160;<xsl:text/>
  </xsl:variable>

  <xsl:attribute-set name="FontInfo">
    <xsl:attribute name="size">2</xsl:attribute>
    <xsl:attribute name="color">#556B2F</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontHighlight">
    <xsl:attribute name="size">2</xsl:attribute>
    <xsl:attribute name="color">#DC143C</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontGlobalDetails">
    <xsl:attribute name="size">2</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontEntryName">
    <xsl:attribute name="size">3</xsl:attribute>
    <xsl:attribute name="color">#000080</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontEntryText">
    <xsl:attribute name="size">3</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontInstructions">
    <xsl:attribute name="size">2</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontResponseText">
    <xsl:attribute name="size">2</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontResponseNumber">
    <xsl:attribute name="size">2</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontResponseKey">
    <xsl:attribute name="size">2</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontResponseCode">
    <xsl:attribute name="size">2</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontAnswerType">
    <xsl:attribute name="size">2</xsl:attribute>
    <xsl:attribute name="color">#556B2F</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontEntryInfo">
    <xsl:attribute name="size">2</xsl:attribute>
    <xsl:attribute name="color">#556B2F</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontFilterTextPos">
    <xsl:attribute name="size">2</xsl:attribute>
    <xsl:attribute name="color">#006400</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontFilterTextNeg">
    <xsl:attribute name="size">2</xsl:attribute>
    <xsl:attribute name="color">#8B0000</xsl:attribute>
  </xsl:attribute-set>
  <xsl:attribute-set name="FontDataLocations">
    <xsl:attribute name="size">2</xsl:attribute>
    <xsl:attribute name="color">#800000</xsl:attribute>
  </xsl:attribute-set>

  <xsl:template match="ProjectDetails">
    <HTML>
      <BASEFONT face="Arial"/>
      <FONT face="Arial">
        <HEAD>
          <B>
            <xsl:value-of select="ProjectTitle"/>
          </B>
        </HEAD>
        <BODY>
          <TABLE cellspacing="1" cellpadding="0" width="90%" border="0">
            <xsl:if test="contains(Switches,'BinaryDataFormat')">
              <TR>
                <TD align="right">
                  <FONT xsl:use-attribute-sets="FontInfo">
                    <xsl:value-of select="$Data_storage_file_type"/>
                  </FONT>
                </TD>
                <TD align="left">
                  <FONT xsl:use-attribute-sets="FontHighlight">
                    <xsl:value-of select="$Binary"/>
                  </FONT>
                </TD>
              </TR>
            </xsl:if>
            <xsl:if test="DataCodeOrder">
              <xsl:if test="not(DataCodeOrder='1234567890')">
                <TR>
                  <TD align="right">
                    <FONT xsl:use-attribute-sets="FontInfo">
                      <xsl:value-of select="$Code_order"/>
                    </FONT>
                  </TD>
                  <TD align="left">
                    <FONT xsl:use-attribute-sets="FontHighlight">
                      <xsl:value-of select="DataCodeOrder"/>
                    </FONT>
                  </TD>
                </TR>
              </xsl:if>
            </xsl:if>
            <xsl:if test="contains(Switches,'CardDataFormat')">
              <TR>
                <TD align="right">
                  <FONT xsl:use-attribute-sets="FontInfo">
                    <xsl:value-of select="$Data_record_layout"/>
                  </FONT>
                </TD>
                <TD align="left">
                  <FONT xsl:use-attribute-sets="FontHighlight">
                    <xsl:value-of select="$As_cards"/>
                    <xsl:value-of select="RecordLength"/>
                    <xsl:value-of select="$columns"/>
                  </FONT>
                </TD>
              </TR>
            </xsl:if>
            <xsl:if test="not(contains(Switches,'CardDataFormat'))">
              <TR>
                <TD align="right">
                  <FONT xsl:use-attribute-sets="FontInfo">
                    <xsl:value-of select="$Data_record_layout"/>
                  </FONT>
                </TD>
                <TD align="left">
                  <FONT xsl:use-attribute-sets="FontGlobalDetails">
                    <xsl:value-of select="$As_one_line"/>
                    <xsl:value-of select="RecordLength"/>
                    <xsl:value-of select="$columns"/>
                  </FONT>
                </TD>
              </TR>
            </xsl:if>
            <xsl:if test="DataLocationTreatment='Automatic'">
              <TR>
                <TD align="right">
                  <FONT xsl:use-attribute-sets="FontInfo">
                    <xsl:value-of select="$Serial_number_width"/>
                  </FONT>
                </TD>
                <TD align="left">
                  <FONT xsl:use-attribute-sets="FontGlobalDetails">
                    <xsl:value-of select="WidthSerial"/>
                  </FONT>
                </TD>
              </TR>
            </xsl:if>
            <xsl:if test="not(DataLocationTreatment='Automatic')">
              <TR>
                <TD align="right">
                  <FONT xsl:use-attribute-sets="FontInfo">
                    <xsl:value-of select="$Serial_number_locations"/>
                  </FONT>
                </TD>
                <TD align="left">
                  <FONT xsl:use-attribute-sets="FontGlobalDetails">
                    <xsl:value-of select="LocationSerial"/>-<xsl:value-of select="number(LocationSerial)+number(WidthSerial)-1"/>
                  </FONT>
                </TD>
              </TR>
            </xsl:if>
            <xsl:if test="contains(Switches,'CardDataFormat')">
              <xsl:if test="DataLocationTreatment='Automatic'">
                <TR>
                  <TD align="right">
                    <FONT xsl:use-attribute-sets="FontInfo">
                      <xsl:value-of select="$Card_number_width"/>
                    </FONT>
                  </TD>
                  <TD align="left">
                    <FONT xsl:use-attribute-sets="FontGlobalDetails">
                      <xsl:value-of select="WidthCard"/>
                    </FONT>
                  </TD>
                </TR>
              </xsl:if>
              <xsl:if test="not(DataLocationTreatment='Automatic')">
                <TR>
                  <TD align="right">
                    <FONT xsl:use-attribute-sets="FontInfo">
                      <xsl:if test="number(WidthCard)>1">
                        <xsl:value-of select="$Card_number_locations"/>
                      </xsl:if>
                      <xsl:if test="not(number(WidthCard)>1)">
                        <xsl:value-of select="$Card_number_location"/>
                      </xsl:if>
                    </FONT>
                  </TD>
                  <TD align="left">
                    <FONT xsl:use-attribute-sets="FontGlobalDetails">
                      <xsl:if test="number(WidthCard)>1">
                        <xsl:value-of select="LocationCard"/>-<xsl:value-of select="number(LocationCard)+number(WidthCard)-1"/>
                      </xsl:if>
                      <xsl:if test="not(number(WidthCard)>1)">
                        <xsl:value-of select="LocationCard"/>
                      </xsl:if>
                    </FONT>
                  </TD>
                </TR>
                <TR>
                  <TD align="right">
                    <FONT xsl:use-attribute-sets="FontInfo">
                      <xsl:value-of select="$Card_numbers"/>
                    </FONT>
                  </TD>
                  <TD align="left">
                    <FONT xsl:use-attribute-sets="FontGlobalDetails">
                      <xsl:apply-templates select="CardNumberCollection"/>
                    </FONT>
                  </TD>
                </TR>
              </xsl:if>
              <xsl:if test="not(number(DigitsForCard)=2)">
                <TR>
                  <TD align="right">
                    <FONT xsl:use-attribute-sets="FontInfo">
                      <xsl:value-of select="$Digits_card_numbers"/>
                    </FONT>
                  </TD>
                  <TD align="left">
                    <FONT xsl:use-attribute-sets="FontHighlight">
                      <xsl:value-of select="DigitsForCard"/>
                    </FONT>
                  </TD>
                </TR>
              </xsl:if>
            </xsl:if>
          </TABLE>
          <xsl:apply-templates select="Entries"/>
        </BODY>
      </FONT>
    </HTML>
  </xsl:template>

  <xsl:template match="CardNumber">
    <xsl:if test="CardType='Fixed'">
      <xsl:text/><xsl:value-of select="CardNumberValue"/>&#160;<xsl:text/>
    </xsl:if>
    <xsl:if test="not(CardType='Fixed')">
      <xsl:text/>(<xsl:value-of select="CardNumberValue"/>)&#160;<xsl:text/>
    </xsl:if>
  </xsl:template>

  <xsl:template match="Entry[@EType='Question']">
    <xsl:if test="not(starts-with(@EName, 'ZZZ'))">
      <TABLE cellspacing="1" cellpadding="0" width="100%" border="1" frame="above" rules="cols">
        <xsl:apply-templates select="FiltersApplied"/>
        <TR>
          <TD width="65%" valign="top">
            <FONT xsl:use-attribute-sets="FontEntryName">
              <xsl:value-of select="@EName"/>
            </FONT>
            <FONT xsl:use-attribute-sets="FontEntryText">
              <xsl:text/>&#160;<xsl:value-of select="Text"/>
            </FONT>
            <xsl:if test="Instruct">
              <BR/>
              <FONT xsl:use-attribute-sets="FontInstructions">
                <I>
                  <xsl:value-of select="Instruct/Text"/>
                </I>
              </FONT>
            </xsl:if>
          </TD>
          <TD width="10%" valign="top" align="center">
            <xsl:apply-templates select="@AType"/>
            <xsl:if test="not(@AType='None' or @AType='Verbatim')">
              <xsl:if test="not(Sizes/@Individual='true')">
                <BR/>
                <FONT xsl:use-attribute-sets="FontDataLocations">
                  <xsl:text/>[<xsl:value-of select="@DL"/>
                  <xsl:if test="Sizes">
                    <xsl:if test="number(Sizes/@SWidth) > 1 and number(Sizes/@SRepeats) &lt; 2">
                      <xsl:text/>-<xsl:value-of select="number(@DL + Sizes/@SWidth - 1)"/>
                    </xsl:if>
                    <xsl:if test="number(Sizes/@SWidth) > 0 and number(Sizes/@SRepeats) > 1">
                      <xsl:text/>-<xsl:value-of select="number(@DL + Sizes/@SWidth * Sizes/@SRepeats - 1)"/>
                    </xsl:if>
                    <xsl:text/>]<xsl:text/>
                  </xsl:if>
                </FONT>
              </xsl:if>
            </xsl:if>
          </TD>
          <xsl:if test="not(Sizes/@Individual='true')">
            <TD width="25%" valign="top">
              <xsl:apply-templates select="RoutingAfter"/>
              <xsl:apply-templates select="@EIF"/>
              <xsl:apply-templates select="Range"/>
            </TD>
          </xsl:if>
          <xsl:if test="Sizes/@Individual='true'">
            <TD width="8%" valign="top">
            </TD>
            <TD width="17%" valign="top">
              <xsl:apply-templates select="RoutingAfter"/>
              <xsl:apply-templates select="@EIF"/>
              <xsl:apply-templates select="Range"/>
            </TD>
          </xsl:if>
        </TR>
        <xsl:apply-templates select="Responses"/>
      </TABLE>
    </xsl:if>
  </xsl:template>

  <xsl:template match="Response[../../@EType='Question']">
    <xsl:if test="not(../../Sizes/@Individual='true')">
      <xsl:if test="Text or @RScore">
        <TR>
          <TD valign="top" align="right">
            <FONT xsl:use-attribute-sets="FontResponseText">
              <xsl:value-of select="Text"/>
              <xsl:if test="@RScore">
                <xsl:text/>&#160;(<I>
                  <xsl:value-of select="@RScore"/>
                </I>)<xsl:text/>
              </xsl:if>
            </FONT>
          </TD>
          <TD valign="top" align="center">
            <FONT xsl:use-attribute-sets="FontResponseKey">
              <xsl:if test="@RKey">
                <xsl:value-of select="@RKey"/>
              </xsl:if>
            </FONT>
          </TD>
          <TD valign="top">
            <xsl:apply-templates select="RoutingAfter"/>
            <xsl:apply-templates select="@RF"/>
          </TD>
        </TR>
      </xsl:if>
    </xsl:if>
    <xsl:if test="../../Sizes/@Individual='true'">
      <xsl:variable name="This_loc">
        <xsl:choose>
          <xsl:when test="@RPlus">
            <xsl:value-of select="number(@RPlus)"/>
          </xsl:when>
          <xsl:otherwise>0</xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <xsl:variable name="Last_loc">
        <xsl:choose>
          <xsl:when test="position()=1">-1</xsl:when>
          <xsl:when test="preceding-sibling::*[1]/@RPlus">
            <xsl:value-of select="number(preceding-sibling::*[1]/@RPlus)"/>
          </xsl:when>
          <xsl:otherwise>0</xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <xsl:variable name="This_code" select="string-length(substring-before(../../../../DataCodeOrder, @RCode))"/>
      <xsl:variable name="Last_code" select="string-length(substring-before(../../../../DataCodeOrder, preceding-sibling::*[1]/@RCode)) + 1"/>
      <xsl:if test="Text or @RScore or not($This_code = $Last_code) or not($This_loc = $Last_loc)">
        <TR>
          <TD valign="top" align="right">
            <xsl:if test="Text or @RScore">
              <FONT xsl:use-attribute-sets="FontResponseText">
                <xsl:value-of select="Text"/>
                <xsl:if test="@RScore">
                  <xsl:text/>&#160;(<I>
                    <xsl:value-of select="@RScore"/>
                  </I>)<xsl:text/>
                </xsl:if>
              </FONT>
            </xsl:if>
          </TD>
          <TD valign="top" align="center">
            <xsl:if test="Text or @RScore">
              <FONT xsl:use-attribute-sets="FontResponseKey">
                <xsl:if test="@RKey">
                  <xsl:value-of select="@RKey"/>
                </xsl:if>
              </FONT>
            </xsl:if>
          </TD>
          <TD valign="top" align="left">
            <xsl:if test="not(contains(@RF, 'RejectSupplemental') or contains(@RF, 'PrintOnly'))">
              <xsl:if test="Text or @RScore">
                <FONT xsl:use-attribute-sets="FontResponseCode">
                  <xsl:text/>&#160;<xsl:value-of select="@RCode"/>
                </FONT>
              </xsl:if>
              <xsl:if test="not(Text or @RScore)">
                <FONT xsl:use-attribute-sets="FontResponseCode">
                  <xsl:text/>&#160;..<xsl:text/>
                </FONT>
              </xsl:if>
              <xsl:if test="not($This_loc=$Last_loc)">
                <FONT xsl:use-attribute-sets="FontDataLocations">
                  <xsl:text/>&#160;[<xsl:value-of select="$This_loc + number(../../@DL)"/>]<xsl:text/>
                </FONT>
              </xsl:if>
            </xsl:if>
          </TD>
          <TD valign="top">
            <xsl:apply-templates select="RoutingAfter"/>
            <xsl:apply-templates select="@RF"/>
          </TD>
        </TR>
      </xsl:if>
    </xsl:if>
  </xsl:template>

  <xsl:template match="Entry[@EType='Filter']">
  </xsl:template>

  <xsl:template match="Entry[@EType='Variable']">
  </xsl:template>

  <xsl:template match="Entry[@EType='Program']">
  </xsl:template>

  <xsl:template match="@AType">
    <xsl:if test="not(.='None')">
      <FONT xsl:use-attribute-sets="FontAnswerType">
        <I>
          <xsl:if test=".='Single'">
            <xsl:value-of select="$Single"/>
          </xsl:if>
          <xsl:if test=".='Multi'">
            <xsl:value-of select="$Multi"/>
          </xsl:if>
          <xsl:if test=".='Integer'">
            <xsl:value-of select="$Integer"/>
          </xsl:if>
          <xsl:if test=".='Float'">
            <xsl:value-of select="$Float"/>
          </xsl:if>
          <xsl:if test=".='Character'">
            <xsl:value-of select="$Character"/>
          </xsl:if>
          <xsl:if test=".='Date'">
            <xsl:value-of select="$Date"/>
          </xsl:if>
          <xsl:if test=".='Time'">
            <xsl:value-of select="$Time"/>
          </xsl:if>
          <xsl:if test=".='Verbatim'">
            <xsl:value-of select="$Verbatim"/>
          </xsl:if>
        </I>
      </FONT>
    </xsl:if>
  </xsl:template>

  <xsl:template match="RoutingAfter[@RTType='Close']">
    <FONT xsl:use-attribute-sets="FontHighlight">
      <xsl:value-of select="$Routing_Close"/>
    </FONT>
  </xsl:template>
  <xsl:template match="RoutingAfter[@RTType='Ineligible']">
    <FONT xsl:use-attribute-sets="FontHighlight">
      <xsl:value-of select="$Routing_Ineligible"/>
    </FONT>
  </xsl:template>
  <xsl:template match="RoutingAfter[@RTType='Text']">
    <FONT xsl:use-attribute-sets="FontInstructions">
      <xsl:value-of select="@RTText"/>
    </FONT>
  </xsl:template>
  <xsl:template match="RoutingAfter[@RTType='Question']">
    <FONT xsl:use-attribute-sets="FontInstructions">
      <xsl:text/>[<xsl:value-of select="@RTText"/><xsl:text/>]<xsl:text/>
    </FONT>
  </xsl:template>

  <xsl:template match="Range">
    <FONT xsl:use-attribute-sets="FontEntryInfo">
      <xsl:text/>Range&#160;<xsl:value-of select="@RangeLow"/>-<xsl:value-of select="@RangeHigh"/>
    </FONT>
  </xsl:template>

  <xsl:template match="@EIF">
    <FONT xsl:use-attribute-sets="FontEntryInfo">
      <xsl:value-of select="@EIF"/>
    </FONT>
  </xsl:template>

  <xsl:template match="@RF">
    <xsl:if test="not(.='')">
      <FONT xsl:use-attribute-sets="FontEntryInfo">
        <xsl:value-of select="."/>
      </FONT>
    </xsl:if>
  </xsl:template>

  <xsl:template match="FiltersApplied">
    <TR>
      <TD width="65%" valign="top">
        <xsl:apply-templates select="BaseFilters" mode="Text"/>
      </TD>
      <TD width="10%" valign="top" align="center">
      </TD>
      <xsl:if test="not(../Sizes/@Individual='true')">
        <TD width="25%" valign="top">
        </TD>
      </xsl:if>
      <xsl:if test="../Sizes/@Individual='true'">
        <TD width="8%" valign="top">
        </TD>
        <TD width="17%" valign="top">
        </TD>
      </xsl:if>
    </TR>
  </xsl:template>

  <xsl:template match="BaseFilters" mode="Text">
    <xsl:if test="Text">
      <FONT xsl:use-attribute-sets="FontFilterTextPos">
        <xsl:value-of select="Text"/>
        <xsl:text/>
      </FONT>
    </xsl:if>
    <xsl:if test="not(Text)">
      <xsl:apply-templates select="BaseFilter[@BFType='WholeEntry' or @BFType='NotWholeEntry']" mode="Text"/>
    </xsl:if>
  </xsl:template>

  <xsl:template match="BaseFilter" mode="Text">
    <xsl:param name="Filter_Name" select="@BFName"/>
    <xsl:if test="position()!=1">
      <BR/>
    </xsl:if>
    <xsl:if test="@BFType='WholeEntry'">
      <xsl:apply-templates select="//Entry[@EName = $Filter_Name]" mode="FilterText"/>
    </xsl:if>
    <xsl:if test="@BFType='NotWholeEntry'">
      <xsl:apply-templates select="//Entry[@EName = $Filter_Name]" mode="NotFilterText"/>
    </xsl:if>
  </xsl:template>

  <xsl:template match="Entry" mode="FilterText">
    <FONT xsl:use-attribute-sets="FontFilterTextPos">
      <xsl:value-of select="Text"/>
    </FONT>
  </xsl:template>

  <xsl:template match="Entry" mode="NotFilterText">
    <FONT xsl:use-attribute-sets="FontFilterTextNeg">
      <xsl:value-of select="$Filter_Not"/>
      <xsl:value-of select="Text"/>
    </FONT>
  </xsl:template>

</xsl:stylesheet>
